#include <g2.h>
#include <win32/g2_win32.h>
#include "canevas.h"

const int TAILLE_PAR_DEFAUT = 400;
const int COULEUR_PAR_DEFAUT = 1;


using namespace std;
//
// Constructeur qui cre un canevas
// entree : taille en X
//          taille en Y
//          couleur de fond
// Sortie : le canevas
canevas::canevas(int tX, int tY, int fond)
{
   tailleX=tX;
   tailleY=tY;
   couleurDeFond=fond;
   identificateur = g2_open_win32(tailleX,tailleY,"test",0);
   g2_set_background(identificateur, couleurDeFond);
}
//
// Constructeur qui cre un canevas avec une couleur de fond par defaut
// entree : taille en X
//          taille en Y
// Sortie : le canevas
canevas::canevas(int tX, int tY)
{
   tailleX=tX;
   tailleY=tY;
   couleurDeFond=COULEUR_PAR_DEFAUT;
   identificateur = g2_open_win32(tailleX,tailleY,"test",0);
   g2_set_background(identificateur, couleurDeFond);
}
//
// Constructeur qui cre un canevas avec une taille par defaut
// entree : couleur de fond
// Sortie : le canevas
canevas::canevas(int fond)
{
   tailleX=TAILLE_PAR_DEFAUT;
   tailleY=TAILLE_PAR_DEFAUT;
   couleurDeFond=fond;
   identificateur = g2_open_win32(tailleX,tailleY,"test",0);
   g2_set_background(identificateur, couleurDeFond);

}
//
// Constructeur qui cre un canevas avec une taille par defaut
// et unr couleur par defaut
//
// entree : couleur de fond
// Sortie : le canevas

canevas::canevas()
{
   tailleX=TAILLE_PAR_DEFAUT;
   tailleY=TAILLE_PAR_DEFAUT;
   couleurDeFond=COULEUR_PAR_DEFAUT;
   identificateur = g2_open_win32(tailleX,tailleY,"test",0);
   g2_set_background(identificateur, couleurDeFond);
}
//
// Destructeur qui est appele a la fin du programme
// pour fermer le canevas
//
canevas::~canevas()
{
    cout << "Fermeture canevas................." << endl;
    g2_close(identificateur);
}
//
// Foncion qui efface tous les dessins du canevas
//
void canevas::effacer()
{
   g2_clear(identificateur);
}
