/**
    \file calcul_aire_et_circonference_avec_fonctions.cpp

    \brief calcul d'aire et de circonference

    Ce programme calcule l'aire et la circonference d'un
    cercle et affiche le resultat.

    \author Gabriel Girard
    \date aout 1994 (création)
    \date 25 aout 2003 (dernière version)
    \version 1.1 : 25 aout 2003, mise a jour, Benoit Fraikin
    \version 1.0 : aout 1994, Gabriel Girard

    \b Entree:
        \li rayon (float)

    \b Sortie:
        \li aire (float),
        \li circonference (float)

  */
#include <iostream>

using namespace std;

/**
    \brief calcul d'aire et de circonference
 */
int main()
{
    // fonctions utiles
    float calcule_aire(float);
    float calcule_circonference(float);

    // constantes et variables locales
    float rayon,         // entree : rayon du cercle
          aire,          // sortie : aire du cercle
          circonference; // sortie : circonference

    // Obtenir le rayon
    cout << "Entrez le rayon : ";
    cin >> rayon;
    cout << endl;

    // Calculer aire
    aire = calcule_aire(rayon);

    // Calculer circonference
    circonference = calcule_circonference(rayon);

    // Imprimer le resultat
    cout << " L'aire d'un cercle est " << aire << endl;
    cout << " La circonference d'un cercle est : "
         << circonference << endl;

    return 0;
}  // fin main()

/**
   \brief Cette fonction calcule l'aire d'un cercle

   Calcule l'aire d'un cercle dont le rayon est passe en parametre.
   L'aire vaut \c PI * (\c rayon)^2.
   La constante \c PI est approximee a 3,14159.

   \param[in] rayon le rayon du cercle dont on veut obtenir l'aire
   \return l'aire du cercle de rayon \c rayon
 */
float calcule_aire(float rayon)
{
    // fonctions utilisees
    float carre_float(float);

    // constante
    float PI = 3.14159;

    return(PI * carre_float(rayon));

} // fin calcule_aire

/**
   \brief Cette fonction calcule la circonference d'un cercle

   Calcule la circonference d'un cercle dont le rayon est passe en parametre.
   La circonference vaut 2 * \c PI * \c rayon.
   La constante \c PI est approximee a 3,14159.

   \param[in] rayon le rayon du cercle dont on veut connaitre la circonference
   \return la circonference du cercle de rayon \c rayon
 */

float calcule_circonference(float rayon)
{
    // constante
    const float PI = 3.14159;

    return(2.0 * PI * rayon);

} // fin calcule_circonference


/**
  \brief Cette fonction calcule le carre d'un nombre.

  Calcule le carre du nombre passe en parametre.

  \param[in] nbr un nombre
  \return le carre du nombre \c nbr
 */
float carre_float(float nbr)
{
    return nbr * nbr;

} // fin carre_float


