/***************************************************************/
/* Fichier : paie.cc                                           */
/*                                                             */
/* Programme qui calcule le salaire brut et le salaire net     */
/* d'un employe connaissant son nombre d'heures travaillees et */
/* le taux horaire correspondant. Une taxe de $25 s'applique   */
/* pour tout gain inferieur a $250. Un taux de taxation de 10% */
/* s'applique pour tout gain inferieur a $750. Un taux de      */
/* taxation de 15% s'applique sur l'excedent de $750, le cas   */
/* echeant.                                                    */
/*                                                             */
/*     Auteur : Gerard Houdeville                              */
/*     Date de creation : 16-septembre-94                      */
/*     Date de modification :                                  */
/*                                                             */
/*     Entree :                                                */
/*             Nombre d'heures travaillees                     */
/*             Taux horaire                                    */
/*     Sortie :                                                */
/*             Salaire brut                                    */
/*             Salaire net                                     */
/***************************************************************/
#include <iostream>

using namespace std;

int main()
{
  //fonctions utilisees
  void mode_emploi(const float, const float, const float,
        	    const float, const float) ;
     // taxe minimale, premier seuil, second seuil
     // premier taux, second taux
  float salaire_brut(float, float) ;
     // nombre d'heures, taux horaire
  float salaire_net(float, const float, const float, 
        	    const float,const float, const float) ;
    // salaire brut, taxe minimale, premier seuil, second
    // seuil, premier taux, second taux

  //constantes locales
  const float taxe_min = 25.0 ; //taxe minimale
  const float seuil1 = 250.0 ;  //premier seuil de taxation
  const float seuil2 = 750.0 ;  //second seuil de taxation
  const float taux1 = 10.0 ;    //premier taux de taxation
  const float taux2 = 15.0 ;	//second taux de taxation

  //variables locales 
  float heures ;	  //nombre d'heures travaillees
  float taux_hor ;	  //taux horaire
  float brut ;  	  //salaire brut
  float net ;		  //salaire net

  //afficher le mode d'emploi pour l'usager
  mode_emploi(taxe_min, seuil1, seuil2, taux1, taux2);

  //Obtenir les donnees: nombre d'heures et taux horaire
  cout << "Nombre d'heures travaillees par l'employe: " ;
  cin >> heures ;
  cout << "Taux horaire pour cet employe: " ;
  cin >> taux_hor ;

  //Calculer le salaire brut
  brut = salaire_brut(heures, taux_hor) ;

  //Calculer le salaire net
  net=salaire_net(brut,taxe_min,seuil1,seuil2,taux1,taux2);

  //Afficher les salaires brut et net
  cout << endl << endl << "Le salaire brut de l'employe est: $"
       << brut << endl ;
  cout << endl <<"le salaire net de cet employe est : $"
       << net << endl ;
}

/************************************************************/
/*                                                          */
/* Fonction qui affiche le mode d'emploi du programme a son */
/* utilisateur                                              */
/*                                                          */
/*     Auteur : Gerard Houdeville                           */
/*     Date de creation : 16-septembre-94                   */
/*     Date de modification :                               */
/*                                                          */
/*     Entree :                                             */
/*             montant de la taxe minimale                  */
 /*         niveau du premier seuil de taxation             */
/*             niveau du second seuil de taxation           */
/*             taux de la taxe a partir du premier seuil    */ 
/*           taux de la taxe a partir du second seuil       */
/*     Sortie :                                             */
/************************************************************/

void mode_emploi(const float min, const float montant1, 
                 const float montant2, const float taux1, 
		 const float taux2)
{
  cout<<"Ce programme calcule le salaire brut et le salaire "
      << endl ;
  cout << "net d'un employe. Une taxe fixe de $" 
       << min << " est imposee " << endl ;
  cout << "pour tout salaire brut inferieur a $" 
       << montant1 << " . " << endl ;
  cout << "Une taxe de " << taux1 
       << "% est imposee pour tout salaire " << endl ;
  cout << "brut compris entre $" << montant1 << " et $" 
       << montant2 << " ." << endl ;
  cout <<  "De plus une taxe de " << taux2 << "% est imposee " 
       << endl ;
  cout << "sur l'exedent de $" << montant2 << " ." << endl 
       << endl ;
  cout << "Vous devez entrer le nombre d'heures travaillees "
  	  << endl ;
  cout << "ainsi que le taux horaire lorsque demande par le " 
      << endl ;
  cout << "programme. Faites <return> apres l'introduction de"
  cout << endl << " chaque valeur." << endl << endl ;
}

/******************************************************/
/* Fonction qui calcule le salaire brut               */
/*                                                    */
/*     Auteur : Gerard Houdeville                     */
/*     Date de creation : 16-septembre-94             */
/*     Date de modification :                         */
/*                                                    */
/*     Entree :                                       */
/*             nombre d'heures travaillees            */
/*             taux horaire                           */
/*     Sortie :                                       */
/*              salaire brut                          */
/******************************************************/

float salaire_brut(float nombre, float taux_horaire)
{
        return (nombre * taux_horaire) ;
}


/******************************************************/
/* Fonction qui calcule le salaire net                */
/*                                                    */
/*     Auteur : Gerard Houdeville                     */
/*     Date de creation : 16-septembre-94             */
/*     Date de modification :                         */
/*                                                    */
/*     Entree :                                       */
/*             salaire brut                           */
/*             taxe minimale                          */
/*             premier seuil d'imposition             */
/*             second seuil d'imposition              */
/*             taux de la premiere imposition         */
/*             taux de la seconde imposition          */
/*     Sortie :                                       */
/*              salaire net                           */
/******************************************************/

float salaire_net(float sal_brut, const float taxe_m, 
                  const float impos1, const float impos2, 
		  const float taux1, const float taux2)
{
   float deduction ;	   //montant de taxe a payer
   if ( sal_brut < impos1 )
  	   deduction = taxe_m ;
   else
       if (sal_brut < impos2)
           deduction = sal_brut * taux1 / 100 ;
       else
           deduction = (impos2 * taux1 /100 ) +
  		       ((sal_brut -impos2) * taux2 / 100) ;
   return ( sal_brut - deduction) ;
}

