#include <iostream>
#include <string>
#include <iomanip>
#include <cstdlib>

#define NB_MAX_COURS 5
#define NB_MAX_DEVOIRS_PAR_COURS 10

using namespace std;

typedef unsigned int type_matricule;
typedef unsigned short int type_note;

enum type_departement {bio, inf, phy, mat, chi};
enum type_cote {E, D, C, B, A};

struct type_adresse {
    unsigned short int numero;
    string nomDeRue;
    string codePostal;
    string ville;
};

struct type_bulletin {
    type_note intra;
    type_note final;
    unsigned short int nbNotes;
    type_note devoir[NB_MAX_DEVOIRS_PAR_COURS];
    type_note moyenne;
    type_cote cote;
};

struct type_etudiant {
    type_matricule matricule;
    string nom;
    type_departement departement;
    type_adresse adresse;
    type_bulletin noteDuCours[NB_MAX_COURS];
    unsigned short int nbCours;
    type_note moyenne;
    type_note_lettre cote;
};

int main () {

    return 0;

}

/*
    Ensuite creer les fonctions 
            void ajouterCours(type_etudiant&);
            void ajouterNoteIntra(type_note, type_bulletin&);
            void ajouterNoteFinale(type_note, type_bulletin&);
            void ajouterUneNoteDeDevoir(type_note, type_bulletin&);
          
*/
type_etudiant creerEtudiant (type_matricule matricule, 
                             string nom, 
                             string nomDepartement,
                             type_adresse adresse) {

    type_departement creerDepartement (string);

    type_etudiant nouvelEtudiant;

    nouvelEtudiant.nom = nom;
    nouvelEtudiant.matricule = matricule;
    nouvelEtudiant.departement = creerDepartement(nomDepartement) ;
    nouvelEtudiant.adresse = adresse;
    nouvelEtudiant.nbCours = 0;
    nouvelEtudiant.moyenne = 0;

    return nouvelEtudiant;
}

string etudiantToString(type_etudiant etudiant) {

    string departementToString (type_departement);
    string integerToString (type_matricule);

    return  "Matricule : " + integerToString(etudiant.matricule) + "\n"
            + "Nom : " + etudiant.nom + "\n"
            + "Departement : " + departementToString(etudiant.departement);

}

type_adresse creerAdresse (unsigned short int numero, string rue,
                           string ville, string codePostal) {

    type_adresse nouvelleAdresse;

    nouvelleAdresse.numero = numero;
    nouvelleAdresse.nomRue = rue;
    nouvelleAdresse.codePostal = codePostal;
    nouvelleAdresse.ville = ville;

    return nouvelleAdresse;

}

string adresseToString (type_adresse adresse) {
    
    return numero + " " + nomRue + ", " + ville + " " + codePostal ;

}

type_bulletin creerBulletin() {

    type_bulletin nouveauBulletin;

    nouveauBulletin.intra = 0;
    nouveauBulletin.final = 0;
    nouveauBulletin.nbNotes = 0;
    nouveauBulletin.moyenne = 0;
    nouveauBulletin.cote = E;

    return nouveauBulletin;

}

string bulletinToString(type_bulletin bulletin) {

    string integerToString(unsigned int);
    string coteToString(type_cote);
    
    string description;

    description = "Note intra : " + integerToString(bulletin.intra) + "\n" +
                  "Note final : " + integerToString(bulletin.final);
    
    for (int i=0; i < bulletin.nbNotes; i++) {
        description += " Devoir " + integerToString(i+1) + " : " +
                       integerToString(bulletin.note[i]) + "\n" ;
    }
    
    description += "Moyenne : " + integerToString(bulletin.moyenne) + "\n" +
                   "Cote : " + coteToString(bulletin.cote) + "\n" ;

    return description;

}

type_cote convertirNote(type_note note) {

    type_cote cote;

    if (note < 20) {
        cote = E;
    } else if (note < 40) {
        cote = D;
    } else if (note < 60) {
        cote = C;
    } else if (note < 80) {
        cote = B;
    } else {
        cote = A;
    }
    
    return cote;

}

string coteToString(type_cote cote) {

    string lettre;

    switch (cote) {
        case A: lettre = "A" ;
                break ;
        case B: lettre = "B" ;
                break ;
        case C: lettre = "C" ;
                break ;
        case D: lettre = "D" ;
                break ;
        case E: lettre = "E" ;
                break ;
    }

    return lettre;

}

type_departement creerDepartement (string nomDepartement) {

    type_departement nouveauDepartement;

    if (nomDepartement == "chimie") {
        nouveauDepartement = chi ;
    } else if (nomDepartement == "mathematique") {
        nouveauDepartement = mat ;
    } else if (nomDepartement == "biologie") {
        nouveauDepartement = bio ;
    } else if (nomDepartement =="physique") {
        nouveauDepartement = phy ;
    } else if (nomDepartement == "informatique"){
        nouveauDepartement = inf ;
    } else {
        cerr << "Erreur le nom du departement est invalide" << endl;
        nouveauDepartement = inf ;
    }
    
    return nouveauDepartement;

}

string departementToString (type_departement departement) {

    string description;

    switch (departement) {
        case chi: description = "chimie";
                  break;
        case bio: description = "biologie";
                  break;
        case phy: description = "physique";
                  break;
        case mat: description = "mathematique";
                  break;
        case inf: description = "informatique";
                  break;
        default:
             cerr << "Erreur, le departement est indefini" << endl;
             description = "";
    }

    return description;

}

string integerToString(unsigned int integerValue) {

    char numberInCharArray[24];
    
    sprintf(numberInCharArray, "%u", integerValue);

    string numberInString(numberInCharArray);
    
    return numberInString;

}

void modifierAdresse(type_adresse nouvelleAdresse, type_etudiant &etudiant) {

    etudiant.adresse = nouvelleAdresse;
    
    return;

}

void ajouterCours (type_etudiant &etudiant) {

    etudiant.noteDuCours[etudiant.nbCours] = creerBulletin() ;
    etudiant.nbCours += 1;

    return;

}

void ajouterNoteIntra (type_note noteIntra, type_bulletin &bulletin) {

    bulletin.intra = noteIntra;
    bulletin.moyenne = (int) floor( ( bulletin.moyenne * bulletin.nbNotes
                                      + bulletin.intra 
                                      ) /
                                    ( bulletin.nbNotes + 1.0 )
                                  );
    bulletin.cote = convertirNote(bulletin.moyenne);

    return;

}

void ajouterNoteFinal (type_note noteFinale, type_bulletin &bulletin) {

    bulletin.final = noteFinale;
    bulletin.moyenne = (int) floor( ( bulletin.moyenne * bulletin.nbNotes
                                      + bulletin.intra + bulletin.final 
                                      ) /
                                    ( bulletin.nbNotes + 2.0 )
                                  );
    bulletin.cote = convertirNote(bulletin.moyenne);

    return;

}

void ajouterUneNoteDeDevoir (type_note noteDeDevoir, type_bulletin &bulletin) {

    bulletin.devoir[bulletin.nbCours] = noteDeDevoir ;
    bulletin.nbNotes += 1;
    bulletin.moyenne = (int) floor( ( bulletin.moyenne * (bulletin.nbNotes - 1)
                                      + bulletin.intra + noteDeDevoir 
                                      ) /
                                    ( bulletin.nbNotes + 1.0 )
                                  );`
    bulletin.cote = convertirNote(bulletin.moyenne);

    return;

}
