#include <iostream>
#include <string>
#include <iomanip>
#include <cstdlib>

using namespace std;

typedef unsigned int type_matricule;

enum type_departement {bio, inf, phy, mat, chi};

struct type_etudiant {
    type_matricule matricule;
    string nom;
    type_departement departement;
};

int main () {

    type_etudiant creerEtudiant (type_matricule, string, string);
    string etudiantToString (type_etudiant);

    type_etudiant etudiant;
    string nom;
    type_matricule matricule;
    string nomDepartement;

    cout << "Entrer le nom de l'etudiant : " << endl;
    cin >> nom ;
    cout << "Entrer son numero matricule : " << endl;
    cin >> matricule ;
    cout << "Entrer son departement d'appartenance : " << endl;
    cin >> nomDepartement ;

    etudiant = creerEtudiant (matricule, nom, nomDepartement) ;

    cout << "L'etudiant entre a pour caracteristique : " << endl
         << etudiantToString(etudiant)
         << endl ;
         
    return 0;

}

type_etudiant creerEtudiant (type_matricule matricule, 
                             string nom, string nomDepartement) {

    type_departement creerDepartement (string);

    type_etudiant nouvelEtudiant;

    nouvelEtudiant.nom = nom;
    nouvelEtudiant.matricule = matricule;
    nouvelEtudiant.departement = creerDepartement(nomDepartement) ;

    return nouvelEtudiant;
}

string etudiantToString(type_etudiant etudiant) {

    string departementToString (type_departement);
    string integerToString (type_matricule);

    return  "Matricule : " + integerToString(etudiant.matricule) + "\n"
            + "Nom : " + etudiant.nom + "\n"
            + "Departement : " + departementToString(etudiant.departement);

}

type_departement creerDepartement (string nomDepartement) {

    type_departement nouveauDepartement;

    if (nomDepartement == "chimie") {
        nouveauDepartement = chi ;
    } else if (nomDepartement == "mathematique") {
        nouveauDepartement = mat ;
    } else if (nomDepartement == "biologie") {
        nouveauDepartement = bio ;
    } else if (nomDepartement =="physique") {
        nouveauDepartement = phy ;
    } else if (nomDepartement == "informatique"){
        nouveauDepartement = inf ;
    } else {
        cerr << "Erreur le nom du departement est invalide" << endl;
        nouveauDepartement = inf ;
    }
    
    return nouveauDepartement;

}

string departementToString (type_departement departement) {

    string description;

    switch (departement) {
        case chi: description = "chimie";
                  break;
        case bio: description = "biologie";
                  break;
        case phy: description = "physique";
                  break;
        case mat: description = "mathematique";
                  break;
        case inf: description = "informatique";
                  break;
        default:
             cerr << "Erreur, le departement est indefini" << endl;
             description = "";
    }

    return description;

}

string integerToString(unsigned int integerValue) {

    char numberInCharArray[24];
    
    sprintf(numberInCharArray, "%u", integerValue);

    string numberInString(numberInCharArray);
    
    return numberInString;

}
